/*
 * A n t l r  T r a n s l a t i o n  H e a d e r
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-1994
 * Purdue University Electrical Engineering
 * With AHPCRC, University of Minnesota
 * ANTLR Version 1.33
 */
#include <stdio.h>
#define ANTLR_VERSION   133
#define ZZCAN_GUESS
#include <setjmp.h>
#define zzSET_SIZE 4
#include "antlr.h"
#include "tokens.h"
#include "dlgdef.h"
#include "mode.h"
#ifndef PURIFY
#define PURIFY(r,s)
#endif
ANTLR_INFO

#include "myToken.h"
#include "myAST.h"
#include "myPanic.h"
#include "myTokenBuffer.h"
#include "DLGLexer.h"

int main() {
    
  ASTBase *     root(0);
    AST *           rootCopy;
    
  {
        DLGFileInput    in(stdin);
        DLGLexer        lexer(&in,2000);
        MyTokenBuffer   pipe(&lexer,1);
        ANTLRToken      aToken( (ANTLRTokenType)0 );
        P           parser(&pipe);
        
    parser.noGarbageCollectTokens();
        printf("Garbage collection of ANTLRTokens disabled\n\n");
        
    lexer.setToken(&aToken);
        AST::clearList();       // remove statically constructed ASTs
        AST::clearCounter();
        ANTLRToken::clearList();    // remove statically constructed Tokens
        ANTLRToken::clearCounter();
        parser.init();
        parser.statement(&root);
        rootCopy=(AST *) root;
    };
    
  if (rootCopy != 0) {
        rootCopy->preorder();
        rootCopy->dumpTree();
        AST::dumpList();
        rootCopy->destroy();
    };
    
  
    printf("AST elements on NoLeak List\n");
    AST::dumpList();
    AST::destroyList();
    printf("Tokens remaining on NoLeak List after AST::destroyList\n");
    ANTLRToken::dumpList();
    ANTLRToken::destroyList();
    fclose(stdin);
    fclose(stdout);
    return 0;
}

void
#ifdef __STDC__
statement(void)
#else
statement()
#endif
{
    zzRULE;
    zzBLOCK(zztasp1);
    zzMake0;
    {
    {
        zzBLOCK(zztasp2);
        zzMake0;
        {
        while ( (LA(1)==ID) ) {
            expr0();
            zzLOOP(zztasp2);
        }
        zzEXIT(zztasp2);
        }
    }
    zzmatch(Eof); zzCONSUME;
    zzEXIT(zztasp1);
    return;
fail:
    zzEXIT(zztasp1);
    if ( zzguessing ) zzGUESS_FAIL;
    zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
    zzresynch(setwd1, 0x1);
    }
}

void
#ifdef __STDC__
expr0(void)
#else
expr0()
#endif
{
    zzRULE;
    zzBLOCK(zztasp1);
    zzMake0;
    {
    zzGUESS_BLOCK
    traceOption(-2);  
    zzGUESS
    if ( !zzrv )
    {
        zzBLOCK(zztasp2);
        zzMake0;
        {
        expr1();
        zzEXIT(zztasp2);
        }
    }
    zzGUESS_DONE
    zzNON_GUESS_MODE {
    traceOption(+2);  
    }
    expr1();
    {
        zzBLOCK(zztasp2);
        zzMake0;
        {
        if ( (LA(1)==5) ) {
            zzmatch(5); zzCONSUME;
            expr0();
        }
        zzEXIT(zztasp2);
        }
    }
    zzEXIT(zztasp1);
    return;
fail:
    zzEXIT(zztasp1);
    if ( zzguessing ) zzGUESS_FAIL;
    zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
    zzresynch(setwd1, 0x2);
    }
}

void
#ifdef __STDC__
expr1(void)
#else
expr1()
#endif
{
    zzRULE;
    zzBLOCK(zztasp1);
    zzMake0;
    {
    zzGUESS_BLOCK
    zzGUESS
    if ( !zzrv )
    {
        zzBLOCK(zztasp2);
        zzMake0;
        {
        expr2();
        zzEXIT(zztasp2);
        }
    }
    zzGUESS_DONE
    {
        zzBLOCK(zztasp2);
        zzMake0;
        {
        expr2();
        zzEXIT(zztasp2);
        }
    }
    {
        zzBLOCK(zztasp2);
        zzMake0;
        {
        while ( (LA(1)==6) ) {
            zzmatch(6); zzCONSUME;
            expr2();
            zzLOOP(zztasp2);
        }
        zzEXIT(zztasp2);
        }
    }
    zzEXIT(zztasp1);
    return;
fail:
    zzEXIT(zztasp1);
    if ( zzguessing ) zzGUESS_FAIL;
    zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
    zzresynch(setwd1, 0x4);
    }
}

void
#ifdef __STDC__
expr2(void)
#else
expr2()
#endif
{
    zzRULE;
    zzBLOCK(zztasp1);
    zzMake0;
    {
    expr3();
    {
        zzBLOCK(zztasp2);
        zzMake0;
        {
        while ( (LA(1)==7) ) {
            zzmatch(7); zzCONSUME;
            expr3();
            zzLOOP(zztasp2);
        }
        zzEXIT(zztasp2);
        }
    }
    zzEXIT(zztasp1);
    return;
fail:
    zzEXIT(zztasp1);
    if ( zzguessing ) zzGUESS_FAIL;
    zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
    zzresynch(setwd1, 0x8);
    }
}

void
#ifdef __STDC__
expr3(void)
#else
expr3()
#endif
{
    zzRULE;
    zzBLOCK(zztasp1);
    zzMake0;
    {
    zzmatch(ID); zzCONSUME;
    zzEXIT(zztasp1);
    return;
fail:
    zzEXIT(zztasp1);
    if ( zzguessing ) zzGUESS_FAIL;
    zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
    zzresynch(setwd1, 0x10);
    }
}
