//
//  diagram.g
//
//  27-Feb-98
//  pccts 1.33MR12
//
//  assists in understanding code generated by antlr for semantic 
//    predicates by showing if/while statement clauses in outline format
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

<<
#include "DLGLexer.h"
#include "myToken.h"
#include "myAST.h"
#include "myPanic.h"
#include "myTokenBuffer.h"

int main() {

   DLGFileInput     in(stdin);
   DLGLexer         lexer(&in);
   MyTokenBuffer    pipe(&lexer,1);
   ANTLRToken       aToken( (ANTLRTokenType)0 );
   P                parser(&pipe);
   ASTBase *        root(0);
   AST *            rootCopy;
   int              eofFound;

   printf ("\nDiagram \"if\"/\"while\" statements generated for predicates"
                " 27-Feb-98\n\n");

   AST::clearList();        // remove statically constructed ASTs
   AST::clearCounter();

   lexer.setToken(&aToken);
   parser.init();

again:
   AST::clearList();        // remove statically constructed ASTs
   AST::clearCounter();
   root=0;
   eofFound=parser.statement(&root);
   rootCopy=(AST *) root;

   if (rootCopy != 0) {
     rootCopy->dumpTree();
     rootCopy->destroy();
   };
/////   AST::dumpList();
   AST::destroyList();

   if (! eofFound) goto again;

   fclose(stdin);
   fclose(stdout);

   return 0;
}
>>

#lexaction <<

#include "P.h"

int depth;

>>

// should have used flex !

#lexclass START

#token  Eof "@"

#token  ZZPF    "zzpf{=[01]}{,}"        <<skip();>>
#token  IF      "if"        
#token  WHILE   "while"     
#token  STOP    "$"
#token  LCB     "\{"                <<skip();>>
#token  RCB     "\}"                <<skip();>>
#token  OR      "\|\|"
#token  AND     "\&\&"
#token  NOT     "\!"
#token          "\!zzpf"            <<return TERM;>>
#token  LP      "\("              
#token  RP      "\)"
#token  WS      "[\t\ ]"            <<skip();>>
#token  NL      "\n"                <<skip();>>
#token  COM     "/\*  ~[\*]*  \*/"  <<skip();>>     /* only simple comments */

#token  TERM    "~[]"
<<if (ch!=')' && ch!='|' && ch!='&' && ch!='!') {
    depth=0;mode(SPAN);more();
  };
>>

#lexclass SPAN
#token  ZZPF    "zzpf{=[01]}{,}"    <<skip();>>
#token  COM     "/\*  ~[\*]*  \*/"  <<skip();>>     /* only simple comments */
#token  STOP    "$"
#token  LP  "\("                    <<depth++;more();>>
#token  RP  "\)"
<<depth--;
  if (depth > 0) {
    more();
  } else if (ch=='|' || ch=='&' || ch=='!' || ch==')') {
    mode(START);
    return TERM;
  } else {
    more();
  };
>>
#token  WS  "[\n\t\ ]"
<<nextpos--;
  *nextpos=0;
  if (depth==0) {
    if (ch=='|' || ch=='&' || ch=='!' || ch==')') {
       mode(START);
       return TERM;
    };
  };
  more();
>>
#token      "@"     <<mode(START);return TERM;>>
#token  TERM    "~[]"
<<if (depth > 0) {
    more();
  } else if (ch=='|' || ch=='&' || ch=='!' || ch==')') {
    mode(START);
  } else {
    more();
  };
>>

class P {

statement > [int eofFound] :
     {IF! | WHILE ! } ( orCond )*
         ( STOP! <<$eofFound=0;>> | Eof! <<$eofFound=1;>> );

orCond  : <<AST *a=0;>>
       andCond (op:OR! <<a=#[$op];>> andCond)*
          <<#0=#(a,#0);>>  ;
andCond : <<AST *a=0;>>
       notCond (op:AND! <<a=#[$op];>> notCond)*
          <<#0=#(a,#0);>>  ;
notCond : NOT^ primary
        | primary
        ;
primary : LP! orCond RP!
    | ( TERM )+
    ;
}
