//
//  flexLexer.cpp
//  18-Sep-95
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */
 
#include "myToken.h"
#include "flexLexer.h"
#include "yyprotos.h"
#include <errno.h>

FlexLexer::FlexLexer(FILE * fileNew) {
  file=fileNew;
  yyrestart(file);
  setLexClass(0);
  foundEOF=0;
}

//
//  negative values for token code indicate EOF on input with absolute
//    value giving one last token code
//  additional calls will always give token code of 0
//

ANTLRAbstractToken * FlexLexer::getToken() {

   ANTLRToken *     result;
   ANTLRTokenType   code;

   result=new ANTLRToken;
   if (foundEOF) {
      result->setType(Eof);
   } else {
     code=(ANTLRTokenType) yylex();
     if (code == 0) {
    foundEOF=1;
        result->setType(Eof);
     } else if (code > 0) {
        result->setType(code);
        result->setText(yytext);
     } else if (code < 0) {
    foundEOF=1;
        result->setType(-code);
        result->setText(yytext);
     };
  };
  return result;
}

FlexLexer::~FlexLexer() {
  int   result;

  freeFlexBuffer();

  result=fclose(file);
  if (result != 0) {
      perror("FlexLexer::~FlexLexer call to fclose()");
  };
}
