//
//  flexex.g
//
//  29-May-97
//  pccts 1.33MR5
//
//  interface flex with antlr
//  tested with flex 2.5.2
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

#header <<
#include "yyprotos.h"
>>

#tokdefs  "flexTokens.h"

<<

#include "myToken.h"
#include "flexLexer.h"

int main() {

   {
     FlexLexer      lexer(stdin);
     ANTLRTokenBuffer   pipe(&lexer,1);
     P          parser(&pipe);

     printf("\n");
     printf("Example of interfacing flex with antlr - 13-Nov-95\n\n");
     printf("Because of parser lookahead the current lexclass may be one\n");
     printf("  token ahead of the last token read by the parser\n\n");

     parser.init();
     parser.setEofToken(Eof);
     parser.statement();
   };

   fclose(stdin);
   fclose(stdout);
   return 0;
}
>>

class P {

statement : ( repeat )* Eof
;
repeat    : <<ANTLRToken *  t;
         int        currentLexClass;
        >>
        ( i:ID      <<t=mytoken($i);>>
            | n:Num     <<t=mytoken($n);>>
        | nl:NL     <<t=mytoken($nl);
                  t->setText("<newline>");
                >>
        | c:Comment     <<t=mytoken($c);>>
        | bc:Bad_Comment    <<t=mytoken($bc);>>
        )
        <<currentLexClass=getLexClass();
          printf("LexClass %s TokenType %s  Text (%s)\n",
                getLexClassName(currentLexClass),
                tokenName(t->getType()),
                t->getText());
        >>
;

}
