//
//  nlex.g
//
//  29-May-97
//  pccts 1.33MR5
//
//  another way of prepending a newline to an input file in order
//    to allow special handling of tokens following a newline
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

<<
#include "nlDLG.h"
#include "myToken.h"
#include "myPanic.h"
#include "ATokenBuffer.h"
#include "myAST.h"

int main() {

   DLGFileInput     in(stdin);
   MyDLG        lexer(&in,2000);
   ANTLRTokenBuffer pipe(&lexer,1);
   ANTLRToken       aToken( (ANTLRTokenType)0 );
   P            parser(&pipe);
   ASTBase *        root(0);
   AST *        rootCopy;

   lexer.setToken(&aToken);
   AST::clearList();        // remove statically constructed ASTs
   AST::clearCounter();
   parser.init();
   parser.statement(&root);
   rootCopy=(AST *) root;

   if (rootCopy != 0) {
////  rootCopy->preorder();
////  rootCopy->dumpTree();
     rootCopy->destroy();
   };
////   AST::dumpList();
   AST::destroyList();

   fclose(stdin);
   fclose(stdout);
   return 0;
}
>>

#token  Eof "@"
#token  ID  "[a-z A-Z]+"
#token  WS  "[\ \t]+"           <<skip();>>
#token  NLWS    "\n[\ ]+"           <<newline();return (NL);>>
#token  NL  "\n"                <<newline();>>
#token  Number  "[0-9]+"
#token  Label   "\n [\ ]* [0-9]+"       <<newline();>>
#token  Comment "\n (C | c | \* ) ~[\n]*"   <<newline();>>
#token  Mult    "\*"

#lexclass START
class P {

statement : (lineStart lineBody )* "@" ;

lineStart : c:Comment       <<mytoken($c)->dumpNode();>>
      | l:Label     <<mytoken($l)->dumpNode();>>
          | NL          <<printf("naked newline\n");>>
;
lineBody  : ( id:ID     <<mytoken($id)->dumpNode();>>
        | n:Number      <<mytoken($n)->dumpNode();>>
        | m:Mult        <<mytoken($m)->dumpNode();>>
        )*
;
}
