//
//  varToken.cpp
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

#include "varToken.h"
#include "string.h"
#include "myPanic.h"
#include <stdio.h>
#include "P.h"

void VarToken::init() {
  pText=0;
}

VarToken::VarToken() {
  init();
  setLine(0);
}

VarToken::~VarToken() {
////   dumpNode("Token Destructor");
   delete [] pText;
   pText=0;
}

VarToken::VarToken(ANTLRTokenType tokenTypeNew) {
   init();
   setType(tokenTypeNew);
   setLine(0);
}

VarToken::VarToken(ANTLRTokenType   tokenTypeNew,
               ANTLRChar *  textNew,   
               int      lineNew) {
   init();
   setType(tokenTypeNew);
   setLine(lineNew);
   setText(textNew);
}         

VarToken::VarToken(const VarToken & from) :
    SimpleToken(from) {
   init();
   setText(from.pText);
};  

//  create new copy of text - not just another reference to existing text

VarToken & VarToken::operator = (const VarToken & from) {

   this->SimpleToken::operator = (from);

   if (this != &from) {
     setText(from.pText);
   };
   return *this;
}      

//  create new copy of text - not just another reference to existing text

void VarToken::setText(const ANTLRChar *s) {

   if (pText != 0) {
      delete [] pText;
      pText=0;
   };
   if (s != 0) {
     pText=new char [strlen(s)+1];
     if (pText == 0) myPanic ("VarToken::setText strdup failed");
     strcpy(pText,s);
   };
}

ANTLRAbstractToken * VarToken::makeToken(ANTLRTokenType      tokenType,
                     ANTLRChar *         text,
                     int             line) {
   return new VarToken(tokenType,text,line);
}

void VarToken::dumpNode(const char * s) {

   char * theText;

   if (s != 0) {printf("%s ",s);};
   if (getType() == Eof) {
     printf("TokenType \"EOF\" Token # %d\n",serial);
   } else {
     if (pText == 0) {
        theText="";
     } else if (strcmp(pText,"\n") == 0) {
    theText="NL";
     } else {
    theText=pText;
     }; 
     printf("TokenType (%s) Text (%s) Token # %d  Line=%d\n",
        P::tokenName(getType()),
        theText,
        serial,     
        getLine());
   };
}
