//
//  wsDLG.cpp
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

#include "wsToken.h"
#include "wsDLG.h"
#include "string.h"

MyDLG::MyDLG(DLGInputStream *in,unsigned bufsize) :
    DLGLexer(in,bufsize) {
  ws=0;
  wslen=0;
  wsmax=0;
  isWS=0;
  foundRealToken=0;
  trackColumns();
}

MyDLG::~MyDLG() {
   delete [] ws;
}

ANTLRAbstractToken * MyDLG::getToken() {

   ANTLRChar *      p;

//
//  first time through (prev==0) there's no previous token
//  this is the only time ws tokens are returned to the caller
//
   if (prev != 0 && prev->getType() == Eof) {
      goto exit;
   };
//
//  only until first non-ws token (foundRealToken) is found
//
   if (foundRealToken == 0) {
      prev=DLGLexer::getToken();
      if (isWS) {
     isWS=0;
         mytoken(prev)->col=begcol();
         mytoken(prev)->setws(mytoken(prev)->getText());
     mytoken(prev)->setText(0);
     goto exit;
      } else {
     foundRealToken=1;
         mytoken(prev)->col=begcol();
     next=prev;
      };
   } else {
      /* nothing */
   };
//
//  the immediately preceding token was a real token which stopped the
//    scan for ws
//  now start the scan for ws following the latest real token
//
   prev=next;
   while (1) {
     next=DLGLexer::getToken(); // <<<===
     if (isWS == 0) break;
     wsAppend(next->getText());
     isWS=0;
   };            
   mytoken(next)->col=begcol();
//
//  now copy trailing ws to previous real token
//
   if (wslen == 0) {
     p=0;
   } else {
     p=new ANTLRChar [wslen+1];
     if (p == 0) panic("MyDLG::getToken new ANTLRChar failed");   
     strcpy(p,ws);
     wslen=0;
   };
   mytoken(prev)->ws=p;
exit:
   return mytoken(prev);
};

void MyDLG::wsAppend(ANTLRChar * s) {

   int      l;
   ANTLRChar *  wsnew;

   l=strlen(s);
   if (wslen+l >= wsmax-1) {
      wsmax=wslen+l+1000;
      wsnew=new ANTLRChar [wsmax];
      if (wsnew == 0) panic("MyDLG::wsAppend new failed");
      if (ws != 0) {
        strcpy(wsnew,ws);
        delete [] ws;
      };
      ws=wsnew;
   };
   strcpy(&(ws[wslen]),s);
   wslen+=l;
};            
