#ifndef WSDLG_H
#define WSDLG_H
//
//  wsDLG.h
//

/*  This file should be accompanied by DISCLAIMER.TXT stating disclaimers */

#include "tokens.h"
#include "stdio.h"
#include "DLGLexer.h"
#include "ATokPtr.h"

struct ANTLRAbstractToken;
struct ANTLRToken;

struct MyDLG : public DLGLexer {

   /* constructor */        MyDLG(DLGInputStream *in,
                      unsigned bufsize=2000);
   /* destructor */ virtual ~MyDLG();

   virtual ANTLRAbstractToken * getToken();

   int              foundRealToken;
   ANTLRTokenPtr        next;
   ANTLRTokenPtr        prev;
   ANTLRChar *          ws;     //  whitespace str
   int              wslen;      //  actual len of str
   int              wsmax;      //  space allocated for str
   void             wsAppend(ANTLRChar *);
};

#endif
